 # Phamm - http://www.phamm.org - <phamm@rhx.it>
 # Copyright (C) 2004,2005 Alessandro De Zorzi <adezorzi AT rhx DOT it>
 # 
 # Phamm is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
 #
 # Phamm is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 # 
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
#
# Spec file for package phamm (Version 0.0.19)
#
# Please submit bugfixes or comments via http://www.phamm.org/
#

%define ver 0.3.1

Name: phamm
Summary: PHP LDAP Mail Manager
Version: %{ver}
Release: 2
License: GPL
URL: http://www.phamm.org/
Group: System/Tools
Packager: adezorzi@rhx.it
Vendor: RHX www.rhx.it
BuildRoot: %{_tmppath}/%{name}-%{version}-build
BuildArch: noarch
BuildRequires: php >= 4.0.5
Requires: webserver, php >= 4.0.5, php-ldap, gnarwl
Obsoletes: phamm
Provides: phamm
Source: http://open.rhx.it/phamm/%{name}-%{version}.tar.gz

# Define the System Path
%define apache_serverroot /var/www/html
%define sysconfigdir /etc

%description
Phamm (PHP LDAP Mail Manager) is inspired to Jamm jamm.sourceforge.net. Phamm is a front-end written in PHP to manage virtual email accounts informations stored in a LDAP directory using the same schema of Jamm (Jamm.schema) and ISPEnv2.schema to add forward and vacation features on a LDAP.
Phamm runs on Apache, OpenLDAP and Postfix based systems. Tested on Linux.

Authors:
--------
    Alessandro De Zorzi <adezorzi@rhx.it>
    Mirko Grava <mgrava@rhx.it>

%prep
%setup -q -n %{name}

%build

%install
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT

#for f in `find . -type d -name .svn` ; do
#	rm -rf $f
#done

mkdir -m 755 -p $RPM_BUILD_ROOT%{apache_serverroot}/%{name}
mkdir -m 755 -p $RPM_BUILD_ROOT%{sysconfigdir}/openldap/schema

# config in etc
#mkdir -m 755 -p $RPM_BUILD_ROOT%{sysconfigdir}/%{name}
#install -m 644 config.inc.php $RPM_BUILD_ROOT/%{sysconfigdir}/%{name}/

# install the cron script
#mkdir -m 755 $RPM_BUILD_ROOT%{sysconfigdir}/cron.daily
#install -m 755 tools/cleaner.sh $RPM_BUILD_ROOT%{sysconfigdir}/cron.daily/

# install the schema files
install -m 755 schema/phamm.schema $RPM_BUILD_ROOT/etc/openldap/schema/
#install -m 755 schema/jamm.schema $RPM_BUILD_ROOT/etc/openldap/schema/
#install -m 755 schema/ISPEnv2.schema $RPM_BUILD_ROOT/etc/openldap/schema/

#chmod 644 `find ./img -type f`

cp -dR index.php logout.php setup.php functions img plugins lang web templates $RPM_BUILD_ROOT%{apache_serverroot}/%{name}
cp -dR config.inc.php $RPM_BUILD_ROOT%{apache_serverroot}/%{name}

#%post
#if [ -f /etc/httpd/httpd.conf ] && ! grep -q "^Include.*phamm.conf" /etc/httpd/httpd.conf; then
#        echo "Include /etc/httpd/phamm.conf" >> /etc/httpd/httpd.conf
#fi
#
#if [ -f /var/lock/subsys/httpd ]; then
#        /etc/rc.d/init.d/httpd reload 1>&2
#fi

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%config(noreplace) %{apache_serverroot}/%name/config.inc.php
%config(noreplace) %{apache_serverroot}/%name/templates/welcome_message.txt
%{apache_serverroot}/%{name}
#/%{sysconfigdir}/cron.daily/cleaner.sh
/etc/openldap/schema/phamm.schema
#/etc/openldap/schema/jamm.schema
#/etc/openldap/schema/ISPEnv2.schema
%doc AUTHORS
%doc CHANGELOG
%doc DOCS.LICENSE
%doc IMAGES.LICENSE
%doc INSTALL
%doc LICENSE
%doc MIGRATE-FROM-JAMM
%doc README
%doc README.plugins
%doc README.translations
%doc THANKS
%doc TODO
%doc examples
%doc tools

%changelog -n phamm
* Thu Feb 11 2005 - adezorzi@rhx.it
- Release 0.2.4
* Thu Jan 27 2005 - adezorzi@rhx.it
- Release 0.2.2
* Tue Jan 22 2005 - adezorzi@rhx.it
- Release 0.2.1
* Tue Jan 11 2005 - adezorzi@rhx.it
- Release 0.1.1
* Fri Jan 07 2005 - adezorzi@rhx.it
- Release 0.1.0
* Mon Dec 27 2004 - adezorzi@rhx.it
- initial release
