<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004 Alessandro De Zorzi and Mirko Grava
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* Modify some properties on multiple aliases
*
* @package functions
* @author Alessandro De Zorzi <adezorzi@rhx.it>
**/

function alias_modify_group ($alias_delete, $alias_active, $editaccounts)
{
    global $connect;
    global $LDAP_BASE;
    global $SUFFIX;
    global $multi;

	// Only for the Array mail_active the value change
    for ($i=0; $i < count($alias_active); $i++)
    {
        $username_domain = explode("@", $alias_active[$i]);
		$domain = $username_domain[1];
		
        // Search the single alias
	    $filter="(&(mail=$alias_active[$i])(objectClass=VirtualMailAlias))";
	    $search=ldap_search($connect, $LDAP_BASE, $filter);
	    $results = ldap_get_entries($connect, $search);
		
        $accountActive=$results[0]["accountactive"][0];

        if ($accountActive=="FALSE")
            $info_active["accountActive"] = "TRUE";

        elseif ($accountActive=="TRUE")
	        $info_active["accountActive"] = "FALSE";

        if ($info_active)
			$r = ldap_modify($connect, "mail=$alias_active[$i],vd=$domain,$LDAP_BASE", $info_active);
    }

// Only for the Array editaccounts
    //
    for ($i=0; $i < count($editaccounts); $i++)
    {
		//$is_postmaster = array();
        $username_domain = explode("@", $editaccounts[$i]);
		$domain = $username_domain[1];

        // Search the single mail
	    $filter="(&(mail=$editaccounts[$i])(objectClass=VirtualMailAlias))";
	    $search=ldap_search($connect, $LDAP_BASE, $filter);
	    $results = ldap_get_entries($connect, $search);
		
        $edit=$results[0]["editaccounts"][0];

        if ($edit == "FALSE" || !$edit)
            $info_editaccounts["editaccounts"] = "TRUE";

        elseif ($edit == "TRUE")
	        $info_editaccounts["editaccounts"] = "FALSE";

        if ($info_editaccounts)
		{
	//		$r=ldap_modify($connect, "mail=$editaccounts[$i],vd=$domain,$LDAP_BASE", $info_editaccounts);

			$r = ldap_modify($connect, "cn=$username_domain[0],vd=$domain,$LDAP_BASE", $info_editaccounts);
		}
    }

	// Delete
    for ($i=0; $i < count($alias_delete); $i++)
    {
        $username_domain = explode("@", $alias_delete[$i]);
		$domain = $username_domain[1];
		
		$s=ldap_delete($connect, "mail=$alias_delete[$i],vd=$domain,$LDAP_BASE");
	}

}

?>
